
;*************************************************************** 
;* Project Name: Mrs laboratrium 2 - Hzi feladat (3. mrs)
;* Project Description:
;	3 emeletes (+fldszint) pletben lift vezrlsnek szimullsa.
;	Egyik LED-sor jelzi a lift helyt, msik a liftajt nyitst;nyomgombokkal lehet megnyitni a liftet.
;	Hvs irnyt a gombhoz tartoz kapcsol mutatja.
;	Az ajt kinyitst mindig azon a szinten kell mutatni, ahol a lift ppen jr.
;	A lift gyorsasga sajt belts szerint llthat,
;	krlbell egy szinte val meglls ideje: 0,25 sec - 1 sec (Timer egysg hasznlata).
;	A program egyetlen hvst trol, amg ki nem szolglja, nem fogad jat.
; 
;* Author: Mayer dm /Y7ZNUX/
;* Lab_group: CDU3
;* Last edited: 2010.03.25.
;
;***************************************************************
;* "AVR ExperimentBoard" port assignment information:
;***************************************************************
;*
;* LED0(P):PortC.0          LED4(P):PortC.4
;* LED1(P):PortC.1          LED5(P):PortC.5
;* LED2(S):PortC.2          LED6(S):PortC.6
;* LED3(Z):PortC.3          LED7(Z):PortC.7        INT:PortE.4
;*
;* SW0:PortG.0     SW1:PortG.1     SW2:PortG.4     SW3:PortG.3
;* 
;* BT0:PortE.5     BT1:PortE.6     BT2:PortE.7     BT3:PortB.7
;*
;***************************************************************
;*
;* AIN:PortF.0     NTK:PortF.1    OPTO:PortF.2     POT:PortF.3
;*
;***************************************************************
;*
;* LCD1(VSS) = GND         LCD9(DB2): -
;* LCD2(VDD) = VCC         LCD10(DB3): -
;* LCD3(VO ) = GND         LCD11(DB4): PortA.4
;* LCD4(RS ) = PortA.0     LCD12(DB5): PortA.5
;* LCD5(R/W) = GND         LCD13(DB6): PortA.6
;* LCD6(E  ) = PortA.1     LCD14(DB7): PortA.7
;* LCD7(DB0) = -           LCD15(BLA): VCC
;* LCD8(DB1) = -           LCD16(BLK): PortB.5 (1=Backlight ON)
;*
;***************************************************************
.include "m128def.inc" ; Definition file for ATmega128 

;* Program Constants 
.equ t1const = $2C3C    ; Timer1 Constant
	; 1 sec => t1const = clock/1024 = 11059200*1024 / 1000000 = $2C3C 

;* Program Variables Definitions 
.def temp = r16 			; Temporary Register
.def ind_hely = r17			; lift honnan indul
.def ind_allap = r18		; lift llapota, ahonnan indul
.def tart_ide_1 = r19		; lift ide tart
.def tart_allap_1 = r20		; ahova tart, ott ez lesz az llapota
.def akt_hely = r21			; lift aktulis helye
.def akt_allap = r22		; lift aktulis llapota
.def tart_ide_2 = r23		; lift vgs llomsa
.def tart_allap_2 = r24		; lift vgs llomsn llapot
.def kapcsolok = r25		; kapcsolok llapota
.def folyamat = r26			; folyamatot trol regiszter
	; 0. bit: ajt becsukva, 1. bit: elrte az 1. clt, 2. bit: ajt nyitva,
	; 3. bit: ajt csukva, 4. bit: elrte a 2. clt


;*************************************************************** 
;* Reset & Interrupt Vectors  
.cseg 
.org $0000 ; Define start of Code segment 
	jmp RESET ; Reset Handler, jmp is 2 word instruction 

	reti ; INT0 Handler on $0002, dummy 
	nop 
	reti ; INT1 Handler, if INTn used, 'reti' and 'nop' 
	     ; will be replaced by 'jmp INTn_Handler_Address'
	nop 
	reti ; INT2 Handler 
	nop 
	reti ; INT3 Handler 
	nop 
	jmp BT_INT_HANDLER ; INT4 Handler 
	 
	jmp BT0_HANDLER ; INT5 Handler 
	 
	jmp BT1_HANDLER ; INT6 Handler 
	 
	jmp BT2_HANDLER ; INT7 Handler 

	reti ; Timer2 Compare Match Handler 
	nop 
	reti ; Timer2 Overflow Handler 
	nop 
	reti ; Timer1 Capture Event Handler 
	nop 
	jmp TIMER1_HANDLER ; Timer1 Compare Match A Handler 
	 
	reti ; Timer1 Compare Match B Handler 
	nop 
	reti ; Timer1 Overflow Handler 
	nop 
	reti ; Timer0 Compare Match Handler 
	nop 
	reti ; Timer0 Overflow Handler 
	nop 
	reti ; SPI Transfer Complete Handler 
	nop 
	reti ; USART0 RX Complete Handler 
	nop 
	reti ; USART0 Data Register Empty Hanlder 
	nop 
	reti ; USART0 TX Complete Handler 
	nop 
	reti ; ADC Conversion Complete Handler 
	nop 
	reti ; EEPROM Ready Hanlder 
	nop 
	reti ; Analog Comparator Handler 
	nop 
	reti ; Timer1 Compare Match C Handler 
	nop
	reti ; Timer3 Capture Event Handler 
	nop 
	reti ; Timer3 Compare Match A Handler 
	nop 
	reti ; Timer3 Compare Match B Handler 
	nop 
	reti ; Timer3 Compare Match C Handler 
	nop 
	reti ; Timer3 Overflow Handler 
	nop 
	reti ; USART1 RX Complete Handler 
	nop 
	reti ; USART1 Data Register Empty Hanlder 
	nop 
	reti ; USART1 TX Complete Handler 
	nop 
	reti ; Two-wire Serial Interface Handler 
	nop 
	reti ; Store Program Memory Ready Handler 
	nop 
	
;*************************************************************** 
;* MAIN program, Initialisation part
.org $0046;
M_INIT:
RESET: 
;***** Stack Pointer init, 
;  	   Set stack pointer to top of RAM *****
		ldi temp, LOW(RAMEND) ; RAMEND = max address in RAM"
		out SPL, temp 	      ; RAMEND value in "m128def.inc" 
		ldi temp, HIGH(RAMEND) 
		out SPH, temp 

;***** LED-ek inicializlsa *****
        ldi temp, 0xff         ; az sszes LED aktv
        out DDRC, temp         ; kimenetre lltjuk ket
        ldi temp, 0b00010001   ; 0. s 4. LED vilgt
        out PORTC, temp        ; 

;***** Kapcsolk inicializlsa *****
		ldi temp, 0xFF
		sts PORTG, temp 	   ; nem tri-state
		ldi temp, 0b00100 	   ; bemenet
		sts DDRG, temp 		   ; irnyregiszter lltsa

;***** Nyomgombok interrupt engedlyezse *****
		ldi temp,0b11111111    ; INT engedelyezese
    	out PORTE,temp
      	ldi temp,0b00001111	   ; I/O irny: bemenet
      	out DDRE, temp
		
		ldi temp, 0b10101010   ; interrupt lenyomsra
		out EICRB, temp
		ldi temp, 0b11110000   ; sszes nyomgomb interruptolhat
		out EIMSK, temp

;***** Timer1 inicializlsa *****
; TCCR1B: Timer/Counter1 Control Register B
; WGM1[3:0] = 0100 -> clear timer on compare match
; 4-3. bit: WGM1[3:2] = 01
; 2-0. bit: elsklz vlasztsa = 101 => clock/1024

;	   	ldi temp, 0b01001		; tesztelshez
	   	ldi temp, 0b01101
  	   	out TCCR1B, temp

; TCCR1A: Timer/Counter1 Control Register A
; 1-0. bit: WGM1[1:0] = 00

   	   	ldi temp, 0
  	   	out TCCR1A, temp

  	   	ldi temp, HIGH(t1const)  ; szmll peridusnak belltsa:
   	   	out OCR1AH, temp
   	   	ldi temp, LOW(t1const)   ; fels - als byte, sorrend fontos!
   	   	out OCR1AL, temp


;***** Vltozk inicializlsa *****
	   	ldi akt_hely, 0b0001000
	   	ldi akt_allap, 0b10001000

;***** Interrupt globlis engedlyezse *****
	   	sei                      ; interruptok engedlyezse


;*************************************************************** 
;* MAIN program, Endless loop part
 
M_LOOP: 

	out PORTC, akt_allap

	jmp M_LOOP ; Endless Loop  


;*************************************************************** 
;* Subroutins, Interrupt routins

;**** BT0 IT kezelse ****
BT0_HANDLER:
	ldi temp, 0b00000000	; nyomgombok interrupt trlse
	out EIMSK, temp

	ldi folyamat, 0x00

	lds kapcsolok, PING 				; kapcsolk llapotnak beolvassa
	sbrc kapcsolok, 0					; Skip if Bit in Reg. Cleared
	ldi tart_ide_2, 0b00001000			; 0. bit 1-es, teht a lift lefele megy majd
	sbrs kapcsolok, 0					; Skip if Bit in Reg. Set
	ldi tart_ide_2, 0b00000001			; 0. bit 0, teht a lift felfele megy majd
	sbrc kapcsolok, 0
	ldi tart_allap_2, 0b10001000		; 0. bit 1-es, teht a lift lefele megy majd
	sbrs kapcsolok, 0
	ldi tart_allap_2, 0b00010001		; 0. bit 0, teht a lift felfele megy majd
	
	ldi tart_ide_1, 0b00001000		; lift ide tart elszr
	ldi tart_allap_1, 0b10001000	; ahova elszr tart, ott ez lesz az llapota

	jmp OSSZES_BUTTON_IT_KOZOS

;**** BT1 IT kezelse ****	 
BT1_HANDLER:
	ldi temp, 0b00000000	; nyomgombok interrupt trlse
	out EIMSK, temp

	ldi folyamat, 0x00

	lds kapcsolok, PING 				; kapcsolk llapotnak beolvassa
	sbrc kapcsolok, 1					; Skip if Bit in Reg. Cleared
	ldi tart_ide_2, 0b00001000			; 0. bit 1-es, teht a lift lefele megy majd
	sbrs kapcsolok, 1					; Skip if Bit in Reg. Set
	ldi tart_ide_2, 0b00000001			; 0. bit 0, teht a lift felfele megy majd
	sbrc kapcsolok, 1
	ldi tart_allap_2, 0b10001000		; 0. bit 1-es, teht a lift lefele megy majd
	sbrs kapcsolok, 1
	ldi tart_allap_2, 0b00010001		; 0. bit 0, teht a lift felfele megy majd

	ldi tart_ide_1, 0b00000100		; lift ide tart elszr
	ldi tart_allap_1, 0b01000100	; ahova elszr tart, ott ez lesz az llapota

	jmp OSSZES_BUTTON_IT_KOZOS

;**** BT2 IT kezelse ****
BT2_HANDLER:
	ldi temp, 0b00000000	; nyomgombok interrupt trlse
	out EIMSK, temp

	ldi folyamat, 0x00

	lds kapcsolok, PING 				; kapcsolk llapotnak beolvassa
	sbrc kapcsolok, 4					; Skip if Bit in Reg. Cleared
	ldi tart_ide_2, 0b00001000			; 0. bit 1-es, teht a lift lefele megy majd
	sbrs kapcsolok, 4					; Skip if Bit in Reg. Set
	ldi tart_ide_2, 0b00000001			; 0. bit 0, teht a lift felfele megy majd
	sbrc kapcsolok, 4
	ldi tart_allap_2, 0b10001000		; 0. bit 1-es, teht a lift lefele megy majd
	sbrs kapcsolok, 4
	ldi tart_allap_2, 0b00010001		; 0. bit 0, teht a lift felfele megy majd

	ldi tart_ide_1, 0b00000010		; lift ide tart elszr
	ldi tart_allap_1, 0b00100010	; ahova elszr tart, ott ez lesz az llapota

	jmp OSSZES_BUTTON_IT_KOZOS

;**** BT_INT IT kezelse ****
BT_INT_HANDLER:
	ldi temp, 0b00000000	; nyomgombok interrupt trlse
	out EIMSK, temp

	ldi folyamat, 0x00

	lds kapcsolok, PING 				; kapcsolk llapotnak beolvassa
	sbrc kapcsolok, 3					; Skip if Bit in Reg. Cleared
	ldi tart_ide_2, 0b00001000			; 0. bit 1-es, teht a lift lefele megy majd
	sbrs kapcsolok, 3					; Skip if Bit in Reg. Set
	ldi tart_ide_2, 0b00000001			; 0. bit 0, teht a lift felfele megy majd
	sbrc kapcsolok, 3
	ldi tart_allap_2, 0b10001000		; 0. bit 1-es, teht a lift lefele megy majd
	sbrs kapcsolok, 3
	ldi tart_allap_2, 0b00010001		; 0. bit 0, teht a lift felfele megy majd

	ldi tart_ide_1, 0b00000001		; lift ide tart elszr
	ldi tart_allap_1, 0b00010001	; ahova elszr tart, ott ez lesz az llapota

;**** Egyb szubrutinok ****

OSSZES_BUTTON_IT_KOZOS:
	mov ind_allap, akt_allap			; lift indulsi llapota
	mov ind_hely, ind_allap
	andi ind_hely, 0b00001111			; fels 4 bit kinullzsa

	cp ind_hely, tart_ide_2				; ha onnan indul, ahova vgl rkeznie kne
	breq IND_HELY_EGYENLO_TART_IDE_2 	; Branch if Equal

	cp ind_hely, tart_ide_1				; ha onnan indul, ahova elszr rkeznie kell
	breq IND_HELY_EGYENLO_TART_IDE_1 	; Branch if Equal

TIMER1_INDITAS:
	clr temp
   	out TCNT1H, temp       ; szmll nullzsa
   	out TCNT1L, temp

   	ldi temp, 0b00010000      	; timer1 match A interrupt enable
;               ...1....		; Timer/Counter1, Output Compare A Match Interrupt Enable
   	out TIMSK, temp    

	reti
		
IND_HELY_EGYENLO_TART_IDE_2:			; indulsi hely megegyezik a vgs ticllal
	cp tart_ide_1, tart_ide_2		   	; 1. cl egyenl-e a 2. cllal
	breq TART_IDE_1_EGYENLO_TART_IDE_2 	; ha igen, ugrs (Branch if Equal)
	jmp TIMER1_INDITAS				   	; ha nem, nincs semmi, timer indtsa

TART_IDE_1_EGYENLO_TART_IDE_2:			; 1. cl megegyezik a 2. cllal (s az undulsi hellyel is)
	ldi temp, 0b11110000  				; sszes nyomgomb interruptolhat ismt
	out EIMSK, temp
	reti								; nem trtnik semmi, lift marad helyben

IND_HELY_EGYENLO_TART_IDE_1:			; indulsi hely megegyezik az els ticllal
	ldi folyamat, 0b00000111			; els 3 lpst kihagyja
	jmp TIMER1_INDITAS

;**** Timer1 IT kezelse ****
TIMER1_HANDLER:
	sbrs folyamat, 0		; 0. bit: ajt becsukva /Skip if Bit in Register Set/
	jmp FOLYAMAT_0			
	sbrs folyamat, 1		; 1. bit: elrte az 1. clt
	jmp FOLYAMAT_1
	sbrs folyamat, 2		; 2. bit: ajt nyitva
	jmp FOLYAMAT_2
	sbrs folyamat, 3		; 3. bit: ajt csukva
	jmp FOLYAMAT_3
	sbrs folyamat, 4		; 4. bit: elrte a 2. clt
	jmp FOLYAMAT_4
				
	jmp FOLYAMAT_5			

FOLYAMAT_0:	; ajtt becsukni
	mov akt_allap, ind_hely
	ldi folyamat, 0b00000001
	reti

FOLYAMAT_1:	; elrni az 1. ticlt
	cp akt_hely, tart_ide_1 ; megasabban van-e a lift, mint ahova elszr megy
	brsh LIFT_LE			; Branch if Same or Higher
	jmp LIFT_FEL

LIFT_LE:
	lsr akt_hely               	; shifteljk a biteket jobbra
	mov akt_allap, akt_hely
	cpse akt_hely, tart_ide_1  	; compare, skip if equal
	reti
	ldi folyamat, 0b00000011	; ha az aktulis hely = ahova elszr tart
	reti

LIFT_FEL:
	lsl akt_hely               	; shifteljk a biteket balra
	mov akt_allap, akt_hely
	cpse akt_hely, tart_ide_1  	; compare, skip if equal
	reti
	ldi folyamat, 0b00000011	; ha az aktulis hely = ahova elszr tart
	reti

FOLYAMAT_2: ; ajtt kinyitni az 1. ticlnl
	mov akt_allap, tart_allap_1
	cp tart_ide_1, tart_ide_2	; ha az 1. ticl = 2. ticl -> STOP
	breq TIMER1_LEALLIT
	ldi folyamat, 0b00000111
	reti

FOLYAMAT_3: ; ajtt becsukni az 1. ticlnl
	mov akt_allap, akt_hely
	ldi folyamat, 0b00001111
	reti

FOLYAMAT_4: ; elrni a vgs ticlt
	cp akt_hely, tart_ide_2		; megasabban van-e a lift, mint ahova msodszor megy
	brsh LIFT_LE_TELJESEN		; Branch if Same or Higher
	jmp LIFT_FEL_TELJESEN
	
LIFT_LE_TELJESEN:
	lsr akt_hely               	; shifteljk a biteket jobbra
	mov akt_allap, akt_hely
	cpse akt_hely, tart_ide_2  	; compare, skip if equal
	reti
	ldi folyamat, 0b00011111	; ha az aktulis hely = ahova 2. tart
	reti

LIFT_FEL_TELJESEN:
	lsl akt_hely               	; shifteljk a biteket balra
	mov akt_allap, akt_hely
	cpse akt_hely, tart_ide_2  	; compare, skip if equal
	reti
	ldi folyamat, 0b00011111	; ha az aktulis hely = ahova 2. tart
	reti

FOLYAMAT_5: ; ajtt kinyitni a vgs ticlnl
	mov akt_allap, tart_allap_2

TIMER1_LEALLIT:
	ldi temp, 0b00000000      	; timer1 match A interrupt disable
		;       ...0....		; Timer/Counter1, Output Compare A Match Interrupt Enable
   	out TIMSK, temp

	ldi temp, 0xFF			; EIFR reigszter trlse (logikai 1-esekkel) a pergsmentestshez
	out EIFR, temp

	ldi temp, 0b11110000  	; sszes nyomgomb interruptolhat ismt
	out EIMSK, temp

	reti

